;		   ( V 2.0 )
;
;		    !
;
;		    PHILIPS PCD 8544 (NOKIA 3310, 5110) 
;		      (Vitaly V Gorbukov) gorbukov@yandex.ru   http://vg.ucoz.ru
;		  UWRTEY (      )
;		   Akl ( . )
;						
;                              
; 
;1.      
; 
; :
;
; LCD_INIT -  
;
; LCD_POS (R17=X, R18=Y) -     (    )
;
; LCD_CHAR (R16=char) -    
;
;
;        
;    17 : 
; +-------+----+----+----+----+----+----+----+----+
; |    |0x00|0x01|0x02|0x03|0x04|0x05|0x06|0x07|
; +-------+----+----+----+----+----+----+----+----+
; | |    |    |    |    |    |    |    |    |
; +-------+----+----+----+----+----+----+----+----+
;
; +-------+----+----+----+----+----+----+----+----+-----+
; |    |0x08|0x09|0x0A|0x0B|0x0C|0x0D|0x0E|0x0F|0x10 |
; +-------+----+----+----+----+----+----+----+----+-----+
; | |    |    |    |    |    |    |    |    |     |
; +-------+----+----+----+----+----+----+----+----+-----+
;
;     58  (4 .    + 1   
;     )
;
;    ( )
;+--------------------------------------------------------------+
;|.include "m32def.inc" ;          |
;|                                                              |
;|.CSEG								|
;|.ORG 0x0000							|
;|		RJMP START					|
;|       . . . . .     . . . . .	|
;|START:							|
;|       . . . .   	  . . . . .		|
;|       . . . . .   . . . . .			|
;|								|
;|								|
;|		RCALL LCD_INIT	;   	|
;|								|
;|		LDI R16, 0x00	;   '0' 		|
;|		RCALL LCD_CHAR					|
;|								|
;|		LDI R16, 0x10	;   ' ' ()	|
;|		RCALL LCD_CHAR					|
;|								|
;|				;  	|																|
;|		LDI R18, 2	;(Y) 3  (  0)	|
;|		LDI R17, 40	;(X) 41   	|
;|		RCALL LCD_POS					|
;|								|
;|		LDI R16, 0x0F	;   'F'		|
;|		RCALL LCD_CHAR					|
;|								|
;|     . . . . .   . . . . .		|
;|								|
;|LOOP:								|
;|		rjmp 	LOOP	;   ()		|
;|								|
;|.include "lcd5110mini.asm" ;   	|
;+--------------------------------------------------------------+
;
;
;
;2.     
;
; --------------------------------------------------------------------------------------------
;
;  ! 
;      3.3 ,       
;  5  -      -  !
;
; +---------------------+
; |   |
; +---------------------+
;         :
;        D (  PORTD;   DDRD)
; ,    A   PORTA  DDRA,      )
;
;     (RST, RES. RESET)
.equ   RSTPORT =PORTd	;      RST (RES, RESET)
.equ   RSTDDR  =DDRd
.equ   RSTPIN  =7	;   

;     (MOSI, DI, DIN)
.equ   MOSIPORT=PORTd	;      MOSI ( DI)
.equ   MOSIDDR  =DDRd
.equ   MOSIPIN  =4	;   

;    \ (DC, D/C)
.equ   DCPORT  =PORTb	;      DC (D/C)
.equ   DCDDR   =DDRb
.equ   DCPIN   =2	;   

;    (CLK, SCK, CLOCK)
.equ   CLKPORT =PORTb	;      CLK (SCK, CLOCK)
.equ   CLKDDR  =DDRb
.equ   CLKPIN  =0	;   

;    SCE (CS)     !
;
;            
;
;     (RST, MOSI, DC, CLK)     \
;    DDR_ONE_LINE,   DDR_MULTI_LINE
;
;       ,      DDR_ONE_LINE
;         DDR_MULTU_LINE  2 
;
;
;
; !           !
;              DDR_ONE_LINE !!!
;
.MACRO  DDR_INIT
;	DDR_ONE_LINE    	;     
	DDR_MULTI_LINE  	;     
.ENDMACRO

;   ,         !
;    Nokia 5110, 3310

LCD_INIT_STR:

.DB 0x21, 0xC2, 0x06, 0x13, 0x20, 0x0C, 0x80, 0x40
.equ LCD_INIT_LEN = 8		;   


;    Simens C55 (  !)

;LCD_INIT_STR:			
;.DB 0x21, 0x09, 0xE0, 0x16, 0x06, 0x20, 0x0C, 0x80, 0x40
;.equ LCD_INIT_LEN = 9		;   




;=========================     !!! ============================


.MACRO DDR_ONE_LINE    	;     

;		RST          MOSI         DC       SCK

in R16, RSTDDR
ori R16, (1<<RSTPIN)|(1<<MOSIPIN)|(1<<DCPIN)|(1<<CLKPIN)
out MOSIDDR, R16

.ENDMACRO



.MACRO DDR_MULTI_LINE  	;     
						
sbi RSTDDR, RSTPIN
sbi MOSIDDR, MOSIPIN
sbi DCDDR, DCPIN
sbi CLKDDR, CLKPIN

.ENDMACRO



LCD_INIT:	; --------------------------------------------------------------  LCD

DDR_INIT				;    

;  

	cbi RSTPORT, RSTPIN		; RST=0


	ldi ZL, low (LCD_INIT_STR*2)	;   

	sbi RSTPORT, RSTPIN		; RST=1

	ldi ZH, high(LCD_INIT_STR*2)
	ldi R17, LCD_INIT_LEN		;   

	cbi DCPORT, DCPIN		; DC=0  




LCD_INIT_loop:				;     

	lpm R16, Z+
	rcall LCD_SENDBYTE
	dec R17
	brne LCD_INIT_loop           

	sbi DCPORT, DCPIN		; DC=1  

	clr R16				;  
	ldi R17, 252



LCD_INIT_CLR_loop:

	rcall LCD_SENDBYTE
	rcall LCD_SENDBYTE
	DEC R17
	BRNE LCD_INIT_CLR_loop

	ret 
					    




LCD_POS: 	;---------------------------------------------------------------- 


;	R17=X	R18=Y

	push	R16

	cbi   	DCPORT, DCPIN	; DC=0

;	ldi     R16, 0x20	;   
;	rcall	LCD_SENDBYTE

	ldi     R16, 0x80
	add     R16, R17	; X 
	rcall	LCD_SENDBYTE

	ldi     R16, 0x40
	add     R16, R18	; Y 
	rcall	LCD_SENDBYTE

	pop	R16
	ret





LCD_SENDBYTE:	;----------------------------------------     (R16 )


	push  R17
	push  R16

	ldi   R17, 8     ;    



LCD_SENDBYTE_loop:

	cbi	MOSIPORT, MOSIPIN   ; mosi=0
	sbrc	R16, 7
	sbi	MOSIPORT, MOSIPIN   ; mosi=1

	sbi	CLKPORT, CLKPIN    ; sck=1
	lsl	R16
	cbi	CLKPORT, CLKPIN    ; sck=0

	dec	R17
	brne	LCD_SENDBYTE_loop

	pop	R16
	pop	R17

	ret


LCD_CHAR:	; ------------------------------------------------------------------  

;	R16 - 

	push	ZL
	push	ZH
	push	R17

	sbi   	DCPORT, DCPIN     ; DC=1

	LDI	ZL, low (lcd_charset*2)
	LDI	ZH, high(lcd_charset*2)

;	LDI	R17, 0
;	LSL     R16
;	LSL     R16
;	ADD	ZL, R16
;	ADC	ZH, R17
;
;	LDI	R17, 4


;*************************************  AKL (.)
LDI R17,6
CLR R15

LSL R16
ROL R15
ADD ZL,R16
ADC ZH,R15
LSL R16
ROL R15
ADD ZL, R16
ADC ZH, R15
;*************************************


LCD_CHAR_LOOP:			 ;    

	LPM	R16, Z+
	RCALL	LCD_SENDBYTE
	DEC	R17
	BRNE	LCD_CHAR_LOOP

	CLR	R16		;   
	RCALL	LCD_SENDBYTE

	pop	R17
	pop	ZH
	pop	ZL
	RET



lcd_charset:	; --------------------------------------     


;	.db 0x3E, 0x41, 0x41, 0x3E	; 0
;	.db 0x44, 0x42, 0x7F, 0x40	; 1
;	.db 0x42, 0x61, 0x51, 0x4E	; 2
;	.db 0x22, 0x41, 0x49, 0x36	; 3
;	.db 0x1C, 0x12, 0x79, 0x10	; 4
;	.db 0x27, 0x45, 0x45, 0x39	; 5
;	.db 0x3E, 0x49, 0x49, 0x32	; 6
;	.db 0x01, 0x71, 0x09, 0x07	; 7
;	.db 0x36, 0x49, 0x49, 0x36	; 8
;	.db 0x26, 0x49, 0x49, 0x3E	; 9
;	.db 0x7C, 0x12, 0x11, 0x7E	; A
;	.db 0x7F, 0x49, 0x49, 0x36	; B
;	.db 0x3E, 0x41, 0x41, 0x22	; C
;	.db 0x7F, 0x41, 0x22, 0x1C	; D 
;	.db 0x7F, 0x49, 0x49, 0x49	; E
;	.db 0x7F, 0x09, 0x09, 0x01	; F
;	.db 0x00, 0x00, 0x00, 0x00	; 


; 16- 

	.db 0x00,0x1E,0x21,0x21,0x1E,0x00 	; 0  --> 0
	.db 0x00,0x00,0x02,0x02,0x3F,0x00 	; 1  --> 1
	.db 0x00,0x23,0x31,0x29,0x27,0x00 	; 2  --> 2
	.db 0x00,0x25,0x25,0x25,0x1A,0x00 	; 3  --> 3
	.db 0x00,0x0C,0x0A,0x09,0x3F,0x00 	; 4  --> 4
	.db 0x00,0x27,0x25,0x25,0x19,0x00 	; 5  --> 5
	.db 0x00,0x1E,0x25,0x25,0x18,0x00 	; 6  --> 6
	.db 0x00,0x01,0x39,0x05,0x03,0x00 	; 7  --> 7
	.db 0x00,0x1A,0x25,0x25,0x1A,0x00 	; 8  --> 8
	.db 0x00,0x06,0x29,0x29,0x1E,0x00 	; 9  --> 9
	.db 0x3C,0x0A,0x09,0x0A,0x3C,0x00 	; 10 --> A
	.db 0x3F,0x25,0x25,0x25,0x1A,0x00 	; 11 --> B
	.db 0x1E,0x21,0x21,0x21,0x21,0x00 	; 12 --> C
	.db 0x3F,0x21,0x21,0x21,0x1E,0x00 	; 13 --> D
	.db 0x3F,0x29,0x29,0x21,0x21,0x00 	; 14 --> E
	.db 0x3F,0x09,0x09,0x01,0x01,0x00 	; 15 --> F
	.db 0x00,0x00,0x00,0x00,0x00,0x00 	; 16 --> 

;  

	.db 0x1E,0x21,0x21,0x29,0x18,0x00 	; 17 --> G
	.db 0x3F,0x08,0x08,0x08,0x3F,0x00 	; 18 --> H
	.db 0x00,0x00,0x21,0x3F,0x21,0x00 	; 19 --> I
	.db 0x00,0x10,0x20,0x20,0x1F,0x00 	; 20 --> J
	.db 0x3F,0x04,0x04,0x0A,0x31,0x00 	; 21 --> K
	.db 0x3F,0x20,0x20,0x20,0x30,0x00 	; 22 --> L
	.db 0x3F,0x02,0x04,0x02,0x3F,0x00 	; 23 --> M
	.db 0x3F,0x02,0x04,0x08,0x3F,0x00 	; 24 --> N
	.db 0x1E,0x21,0x21,0x21,0x1E,0x00 	; 25 --> O
	.db 0x3F,0x09,0x09,0x09,0x06,0x00 	; 26 --> P
	.db 0x1E,0x21,0x31,0x21,0x5E,0x00 	; 27 --> Q
	.db 0x3F,0x09,0x09,0x09,0x36,0x00 	; 28 --> R
	.db 0x22,0x25,0x25,0x25,0x18,0x00 	; 29 --> S
	.db 0x01,0x01,0x3F,0x01,0x01,0x00 	; 30 --> T
	.db 0x1F,0x20,0x20,0x20,0x1F,0x00 	; 31 --> U
	.db 0x0F,0x10,0x20,0x10,0x0F,0x00 	; 32 --> V
	.db 0x1F,0x20,0x18,0x20,0x1F,0x00 	; 33 --> W
	.db 0x31,0x0A,0x04,0x0A,0x31,0x00 	; 34 --> X
	.db 0x03,0x04,0x38,0x04,0x03,0x00 	; 35 --> Y
	.db 0x31,0x29,0x25,0x23,0x21,0x00 	; 36 --> Z

; 

	.db 0x3C,0x12,0x11,0x12,0x3C,0x00 	; 37 --> 
	.db 0x3F,0x25,0x25,0x25,0x3D,0x00 	; 38 --> 
	.db 0x3F,0x21,0x25,0x25,0x1A,0x00 	; 39 --> 
	.db 0x3F,0x01,0x01,0x01,0x01,0x00 	; 40 --> 
	.db 0x20,0x3C,0x22,0x3F,0x20,0x00 	; 41 --> 
	.db 0x3F,0x25,0x25,0x21,0x21,0x00 	; 42 --> 
	.db 0x37,0x08,0x1E,0x08,0x37,0x00 	; 43 --> 
	.db 0x12,0x21,0x25,0x25,0x1A,0x00 	; 44 --> 
	.db 0x3F,0x10,0x08,0x04,0x3F,0x00 	; 45 --> 
	.db 0x3F,0x10,0x09,0x04,0x3F,0x00 	; 46 --> 
	.db 0x3F,0x04,0x04,0x0A,0x31,0x00 	; 47 --> 
	.db 0x3C,0x02,0x01,0x01,0x3F,0x00 	; 48 --> 
	.db 0x3F,0x02,0x04,0x02,0x3F,0x00 	; 49 --> 
	.db 0x3F,0x08,0x08,0x08,0x3F,0x00 	; 50 --> 
	.db 0x1E,0x21,0x21,0x21,0x1E,0x00 	; 51 --> 
	.db 0x3F,0x01,0x01,0x01,0x3F,0x00 	; 52 --> 
	.db 0x3F,0x09,0x09,0x09,0x06,0x00 	; 53 --> 
	.db 0x1E,0x21,0x21,0x21,0x12,0x00 	; 54 --> 
	.db 0x01,0x01,0x3F,0x01,0x01,0x00 	; 55 --> 
	.db 0x07,0x28,0x28,0x28,0x1F,0x00 	; 56 --> 
	.db 0x06,0x09,0x3F,0x09,0x06,0x00 	; 57 --> 
	.db 0x31,0x0A,0x04,0x0A,0x31,0x00 	; 58 --> 
	.db 0x1F,0x10,0x10,0x10,0x1F,0x30 	; 59 --> 
	.db 0x07,0x08,0x08,0x08,0x3F,0x00 	; 60 --> 
	.db 0x3F,0x20,0x3E,0x20,0x3F,0x00 	; 61 --> 
	.db 0x1F,0x10,0x1C,0x10,0x1F,0x30 	; 62 --> 
	.db 0x01,0x3F,0x24,0x24,0x18,0x00 	; 63 --> 
	.db 0x3F,0x28,0x10,0x00,0x3F,0x00 	; 64 --> 
	.db 0x3F,0x24,0x24,0x18,0x00,0x00 	; 65 --> 
	.db 0x00,0x21,0x29,0x29,0x1E,0x00 	; 66 --> 
	.db 0x3F,0x08,0x3F,0x21,0x3F,0x00 	; 67 --> 
	.db 0x00,0x2F,0x19,0x09,0x3F,0x00 	; 68 -->  

;  

	.db 0x00,0x00,0x00,0x00,0x0A,0x00 	; 69 --> :
	.db 0x00,0x0A,0x0A,0x0A,0x0A,0x00 	; 70 --> =
	.db 0x00,0x00,0x00,0x00,0x2F,0x00 	; 71 --> !
	.db 0x00,0x00,0x00,0x1E,0x21,0x00 	; 72 --> (
	.db 0x00,0x00,0x00,0x21,0x1E,0x00 	; 73 --> )
	.db 0x00,0x14,0x08,0x14,0x00,0x00 	; 74 --> *
	.db 0x04,0x04,0x1F,0x04,0x04,0x00 	; 75 --> +
	.db 0x00,0x00,0x00,0x20,0x10,0x00 	; 76 --> ,
	.db 0x00,0x08,0x08,0x08,0x00,0x00 	; 77 --> -
	.db 0x00,0x00,0x00,0x20,0x00,0x00 	; 78 --> .
	.db 0x10,0x08,0x04,0x02,0x01,0x00 	; 79 --> /
	.db 0x46,0x26,0x10,0x08,0x64,0x62	; 80 --> %
	.db 0x28,0x7C,0x28,0x7C,0x28,0x00	; 81 --> #
	.db 0x07,0x05,0x07,0x00,0x00,0x00	; 82 -->  (  )
	.db 0x46,0x26,0x10,0x08,0x64,0x62	; 83 --> %
	.db 0x7F,0x41,0x5D,0x5D,0x51,0x5F	; 84 --> @
	.db 0x00,0x41,0x22,0x14,0x08,0x00	; 85 --> >
	.db 0x00,0x08,0x14,0x22,0x41,0x00	; 86 --> <
	.db 0x00,0x03,0x07,0x00,0x03,0x07	; 87 --> "
	.db 0x00,0x0E,0x07,0x00,0x00,0x00	; 88 --> '
	.db 0x00,0x00,0x7F,0x41,0x00,0x00	; 89 --> [
	.db 0x02,0x04,0x08,0x10,0x20,0x40	; 90 --> \
	.db 0x00,0x00,0x41,0x7F,0x00,0x00	; 91 --> ]  



