;
;
;
;
;
;
;
;
;
;
;
;
;
;
;
;
;
;
;
;  328p
;  16   .
;
;
;
;
;**************************************************************************************************************
;  
;**************************************************************************************************************

.include 	"m328Pdef.inc"		;  ATMega328p


;==============================================================================================================
;   // RAM
;==============================================================================================================
;
;******************************************************************************
;  
;******************************************************************************

.def	Temp =R16
.def	Temp1=R17
.def	Temp2=R18
.def	Temp3=R19
.def	Temp4=R20			;   /  SREG
.def	Temp5=R21 			;   / 
.def	Temp6=R22			; 		
.def	Temp7=R23			; 		
.def	Temp8=R24			;



;******************************************************************************
; 
;******************************************************************************


 .dseg     ;  


;******************************************************************************
; 
;******************************************************************************


; .EQU	Constanta_1= 0x0001 		; 1 ( 16  )


;==============================================================================================================
;   // FLASH // 
;==============================================================================================================

.cseg	


;******************************************************************************
;  
;******************************************************************************	
	

.org 0					; External Pin, Power-on Reset, Brown-out Reset, and Watchdog Reset
rjmp reset				;  
				

; .org OC1Aaddr				; = 0x0016 Timer/Counter1 Compare Match A 
; rjmp OCR1A_COMP



.org ADCCaddr				; ADC Conversion Complete 
rjmp ADC_Conversion			; (    )




.org INT_VECTORS_SIZE			;   


;******************************************************************************
; 
;******************************************************************************

reset:					;  


;******************************************************************************
;   
;******************************************************************************


	cli				;    


;******************************************************************************
; 
;******************************************************************************

	ldi Temp, low(RAMEND)		;  
	out SPL, Temp
	ldi Temp, high(RAMEND)
	out SPH, Temp




;******************************************************************************
;  
;******************************************************************************


;         
;     ,        
;        



;   "B"

	ldi Temp,0b00000010		;   "b" (0-, 1-)
	out DDRB,Temp			; 0000000 - "" 
					 
		
			

	ldi Temp,0b00000000		;  _0   "b" (   )  .
	out PortB,Temp			; 


;   "D"

	ldi Temp,0b01000000		;   "D" (0-, 1-)
	out DDRD,Temp			; 0000000 - "" 
					 
		
			

	ldi Temp,0b00000000		;  _0   "D" (   )   .
	out PortD,Temp			; 



				
;******************************************************************************
;   
;******************************************************************************


; _0 (  1024 )
; 8 
;    ( 3 : ,     )



					

	ldi Temp,(1<<COM0A1)|(0<<COM0A0)|(1<<WGM01)|(1<<WGM00)
	out TCCR0A, Temp	
				
					;    //   ,   
					; 
					; 


					; COM0A1  /   OC1A // 
					; COM0A0  /   OC1A // 
					; COM0B1  /   OC1B // 
					; COM0B0  /   OC1B //  
					; WGM01=1 /  *
					; WGM00=1 /  *





	ldi Temp,(0<<WGM02)|(1<<cs02)|(1<<cs00)	
	out TCCR0B, Temp					


					;   = CK 1:1024 
					;   !!!


					; WGM02=0 /  * 
					; CS02=1  /  
					; CS01=0  /   
					; CS00=0  /   = CK 1:1024 (16/1024=15625) 1   = 0,000064 



					; 16000000:1024=15625 
					; 1:15625=0,000064 

					; 0,000064*256=0,016384 
					; 0,000064*1=0,000064 



	ldi Temp, 0x1E			;   0  255
	out OCR0A, Temp			;  30 ( 0x1E ) 
					;  255 ( 0xFF ) 











;******************************************************************************

; _1 (  1/64 )
; 16 
;        (  1  10  )





	LDI Temp, 0x07						;    
	sts OCR1AH, Temp					;  0,05 ,  3125  ( 0x0C35 ) 
	LDI Temp, 0x53						; 					
	sts OCR1AL,Temp  					; --------------------------------------- 0,10 ,  6250  ( 0x186A ) 
								;  0,03  1875  ( 0x753 )




	ldi Temp, (1<<COM1A1)|(0<<COM1A0)|(1<<wgm11)|(0<<wgm10)	;      ( fast pwm - top = icr )
	sts TCCR1A, Temp					; 

								; COM1A1 /   OC1A
								; COM1A0 /   OC1A 
								; COM1B1 /   OC1B 
								; COM1B0 /   OC1B
								; 
								; 
								; WGM11=1 /  
								; WGM10=0 /  


	ldi Temp, (1<<WGM13)|(1<<WGM12)|(1<<cs12)|(0<<cs10)	;  
	sts TCCR1B, Temp					;     = CK 1:256
								;   !!!

								; ICNC1=0 / 
								; ICES1=0 / 
								; WGM13=1 /  
								; WGM12=1 /  
								; CS12=0
								; CS11=1 /   = CK 1:256 (16/256=62500) 1   = 0,000016 
								; CS10=0 





	LDI Temp, 0x18						;     
	sts ICR1H, Temp						;      
	LDI Temp, 0x6A						; 
	sts ICR1L, Temp						;
								; 1:10=0,1 // 0,1:0,000016=6250  ( 0x186A )
								; 1:7=~0,14 // 0,14:0,000016=8750  ( 0x222E )
								; 1:1=1  // 1:0,000016=62500 
 


;	ldi Temp, (1<<OCIE1A)					;    
;	sts TIMSK1, Temp





	ldi Temp, 0						;   
	sts TCNT1H, Temp
	sts TCNT1L, Temp






;******************************************************************************
;   (     )
;******************************************************************************




;******************************************************************************
;  
;******************************************************************************

;   10  (  0  1023 ) ***************************************

	ldi Temp,(1<<REFS0)|(0<<MUX0)		
	sts ADMUX, Temp	
					; REFS0=1 /   5V /
					; ADLAR=0 /   10  ( 8     2    )
					; MUX0=0  /    ADC0 (PA0)
					; MUX1=0 
					; MUX2=0 
					; MUX3=0 		
					; MUX4=0

	

	ldi Temp, (1<<ADEN)|(1<<ADSC)|(1<<ADATE)|(1<<ADIE)|(7<<ADPS0)
	sts ADCSRA, Temp
					; ADEN=1  /  
					; ADSC=1  /   
					; ADATE=1 /   
					; ADIF=0  /      (   )
					; ADIE=1  /    
					; ADPS2=1
					; ADPS1=1
					; ADPS0=1 /   1/128 ( 16  / 128 = 125  )



;	ldi Temp, (0<<ADTS0)
;	out ADCSRB,Temp


					; ACME=0  /       //   .
					; ADTS2=0
					; ADTS1=0
					; ADTS0=0 /    
					; (       ) //   .





					; *PUD=0 /   ,     //  
					; *PSR10=0 /   _1 //  
					; *PSR2=0 /   _2 //  




;******************************************************************************
;  
;******************************************************************************			

	RCALL	LCD_INIT		;   (  "LCD_INIT"     )


;******************************************************************************
;   
;******************************************************************************

;	sei				;   
	

;*******************************************************************************
;   *****************************************************************
;*******************************************************************************

main_cicle:


	LDI R16, 55			;   ''
	RCALL LCD_CHAR	

	LDI R16, 42			;   ''
	RCALL LCD_CHAR	
					
			
	LDI R16, 49			;   ''
	RCALL LCD_CHAR
						
			
	LDI R16, 52			;   ''
	RCALL LCD_CHAR	
			

	LDI R16, 42			;   ''
	RCALL LCD_CHAR			
		
																				
	LDI R16, 53			;   ''
	RCALL LCD_CHAR
		

	LDI R16, 78			;   '.'
	RCALL LCD_CHAR						
			



	sei				;   



main_cicle_1:

	rjmp main_cicle_1




;*******************************************************************************************************************************
;   
;*******************************************************************************************************************************

ADC_Conversion:




	in temp4,SREG				;  "SREG"/////////////////////////////////////////////////////
	push temp4




;    ***********************************************************************



	lds XL, ADCL				;     
	lds XH, ADCH				; 
						;    0  1023




;    2- *******************************************************

																
	LDI R18, 1				;(Y) 2  (  0)	
	LDI R17, 0				;(X) 0   	
	RCALL LCD_POS



;     ***************************************************************


	mov r16, XL
	mov r17, XH

	rcall HEX_to_BCD



;  16   ******************************************************************

;   R17:R18:R19


;   R16


	mov r16, R19			;  
	rcall printhex
	mov r16, R18			;  
	rcall printhex			; 
	mov r16, R17			;  
	rcall printhex			; 
 


;  **********************************************************************************



;      0  1023 (  1024  )
;       1  10    62500   6250 
;           -   . (   6250  62500 )
;    
;    16-      65536 
;      ICR1  65535,       0,96 -  !!!!
;   1024  65536  64 
;
;  ,         ( 0*64=0 )
;     ICR1  0,       
;         ,    .
;          _1 -        .  !
;
;      ,      (      )
;
;      0,05 ,    3125   ( 0x0C35 ) -       OCR1A
; 3125/64=49 (0x31) (  )
;    49 (0x31) -      
;      5 ,  49    5/1024*49=0,24 
;       
; 
;    4360 
;   5 
;  5V/4360=0,001 (   1  )
; 0,24V/0,001=230-240 
;
;        300 
; :
; 4360  + 300  = 4660 
; 5V/4660  = 0,0008  (   1  )
; 0,0008*300=0,24 


;   64

	LSL XL					;    16-   (    )
	ROL XH					;

	LSL XL					;    16-   (    )
	ROL XH					;

	LSL XL					;    16-   (    )
	ROL XH					;

	LSL XL					;    16-   (    )
	ROL XH					;

	LSL XL					;    16-   (    )
	ROL XH					;


	LSL XL					;    16-   (    )
	ROL XH					;



;    (  62250  6250 )

	MOV Temp, Xh				;    
	sts ICR1H, Temp				;      
	MOV Temp, Xl				; 
	sts ICR1L, Temp				;



;     ICR1 ************************************************************

;    3-

																
	LDI R18, 2				;(Y) 3  (  0)	
	LDI R17, 0				;(X) 0   	
	RCALL LCD_POS

			

;  16  
;    X (XH:XL)

	mov r16, XH
	rcall printhex
	mov r16, XL
	rcall printhex
 




;***************************************************************************************************
;   *******************************************************************************


OCR1A_COMP_EXIT:				; 
   
	pop temp4				;  "SREG" ////////////////////////////////////////////////////
	out SREG, temp4



	RETI					;   






;*******************************************************************************
;     hex ,   . 
;*******************************************************************************

  
;  r16    

printhex: 
   
	push r16		;      (    )
	swap r16		;   ,      
	rcall printhex1		;       
	pop r16			;    


printhex1: 
   
	andi r16, 0x0f		;    ( )
	rcall lcd_char		;      
	ret    



;*******************************************************************************
;   HEX  BCD
;*******************************************************************************

HEX_to_BCD:

;===================================================================
;"bin16BCD5"-  16- 
;   BCD 
;===================================================================
;              :25 + 
;                :25/176 (/) + 
;   :
;   :4(fbinL,fbinH/tBCD0,tBCD1,tBCD2)
;         :


;
.def    fbinL   =r16            ; ,  
.def    fbinH   =r17            ; ,  

;
.def    tBCD0   =r17            ;BCD ,  1  0
.def    tBCD1   =r18            ;BCD ,  3  2
.def    tBCD2   =r19            ;BCD ,  4
;:  fbinH  tBCD0    
;.
;   65535   . 
/*
r17: 0b0011_0101  3  5
r18: 0b0101_0101  5  5
r19: 0b0000_0110  6
*/
bin16BCD5:              ldi     tBCD2,-1
b16BCD5_l1:             inc     tBCD2
                                                                ;255
                        subi    fbinL,low(10000)                ;r17 0101_0101  
                        sbci    fbinH,high(10000)               ;r18 0000_0010
                                                                ;
                        brsh    b16BCD5_l1                      ;1500
                                                                ;r17 0000_0000
                        subi    fbinL,low(-10000)               ;r18 0001_0101
                        sbci    fbinH,high(-10000)              
                                                                
                        ldi     tBCD1,-0x11                             

b16BCD5_l2:             subi    tBCD1,-0x10
                        subi    fbinL,low(1000)
                        sbci    fbinH,high(1000)
    
                        brsh    b16BCD5_l2
    
                        subi    fbinL,low(-1000)
                        sbci    fbinH,high(-1000)

b16BCD5_l3:             inc     tBCD1
                        subi    fbinL,low(100)
                        sbci    fbinH,high(100)
    
                        brsh    b16BCD5_l3
    
                        subi    fbinL,-100
                        ldi     tBCD0,-0x10

b16BCD5_l4:             subi    tBCD0,-0x10
                        subi    fbinL,10
    
                        brsh    b16BCD5_l4
                        subi    fbinL,-10
                        add     tBCD0,fbinL

ret

;******************************************************************



;*******************************************************************************
;  
;*******************************************************************************

.include "lcd5110rus.asm"		;   	






